<template>
  <div class="dictTenantDtl">
    <el-button type="primary" @click="openModal">添加</el-button>
    <div class="content">
      <byTable :source="sourceList.data" :pagination="sourceList.pagination" :config="config" :loading="loading" highlight-current-row @get-list="getList">
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog :title="modalType == 'add' ? '新增' : '编辑'" v-model="dialogVisible" width="400" v-loading="loading">
      <byForm :formConfig="formConfig" :formOption="formOption" v-model="formData.data" :rules="rules" ref="byform"> </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button type="primary" @click="submitForm('byform')" size="large" :loading="submitLoading"> 确 定 </el-button>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "/src/components/byTable/index";
import byForm from "/src/components/byForm/index";
import { computed, ref, watch } from "vue";
const { proxy } = getCurrentInstance();
const loading = ref(false);
const submitLoading = ref(false);
defineProps({
  data: {
    type: Object,
    default: false,
  },
});
watch(proxy.data, () => {
  console.log(proxy.data);
  getList();
});
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  dictKey: [{ required: true, message: "请输入key", trigger: "blur" }],
  dictValue: [{ required: true, message: "请输入val", trigger: "blur" }],
  sort: [{ required: true, message: "请输入排序", trigger: "blur" }],
});
const config = computed(() => {
  return [
    {
      attrs: {
        label: "键",
        prop: "dictKey",
      },
    },
    {
      attrs: {
        label: "值",
        prop: "dictValue",
      },
    },
    {
      attrs: {
        label: "排序",
        prop: "sort",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "修改",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              // 弹窗提示是否删除
              ElMessageBox.confirm("此操作将删除该数据, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
              }).then(() => {
                // 删除
                proxy
                  .post("/dictCommonData/delete", {
                    id: row.id,
                  })
                  .then((res) => {
                    ElMessage({
                      message: "删除成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const formConfig = computed(() => {
  return [
    {
      type: "input",
      prop: "dictKey",
      label: "键",
      required: true,
    },
    {
      type: "input",
      prop: "dictValue",
      label: "值",
    },
    {
      label: "排序",
      prop: "sort",
      type: "input",
      itemType: "number",
    },
  ];
});
const getList = async (req) => {
  console.log(proxy.data.data.code);
  sourceList.value.pagination = {
    ...sourceList.value.pagination,
    ...req,
    dictCode: proxy.data.data.code,
    tenantId: proxy.data.data.tenantId,
  };
  loading.value = true;
  proxy.post("/dictCommonData/page", sourceList.value.pagination).then((message) => {
    console.log(message);
    sourceList.value.data = message.rows;
    sourceList.value.pagination.total = message.total;
    setTimeout(() => {
      loading.value = false;
    }, 200);
  });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {};
};

const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;
    formData.data.dictCode = proxy.data.data.code;
    formData.data.tenantId = proxy.data.data.tenantId;
    proxy
      .post("/dictCommonData/" + modalType.value, formData.data)
      .then((res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      })
      .catch((err) => {
        submitLoading.value = false;
      });
  });
};

const getDtl = (row) => {
  formData.data = { ...row };
  modalType.value = "edit";
  dialogVisible.value = true;
};
getList();
</script>

<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>
